<?php
/*
* Register Globals stress
*/
if (!ini_get('register_globals')) { 
	$register_order = array('GET','POST','COOKIE','SESSION','SERVER'); 
	foreach ($register_order as $order) { 
		if (@count(${'HTTP_'.$order.'_VARS'}) > 0) { 
			extract(${'HTTP_'.$order.'_VARS'}, EXTR_OVERWRITE); 
		} 
	} 
}
$css = showcss();
##################################################################################################
/*
* return: template string
* param: templatename string und extension='htm' string
* usage: siehe function dooutput
* desc: gibt den Inhalt der Template template zurck. Benutzt Cache..
*/
function gettemplate($template,$ext="htm") {
  
  	global $templatedir, $ext, $tplcache, $bsx_conf; 
  	
  	if(! isset($templatedir)) $templatedir = "tpl";
  	if(! isset($bsx_conf)) $bsx_conf = get_config();
  	$tpldir = $bsx_conf[site_path]."".$templatedir;
  	if(! isset($tplcache[$template])) {
		if(file_exists($tpldir."/".$template.".".$ext)) {
			$tplcache[$template] = implode("",file($tpldir."/".$template.".".$ext));
		} 
		elseif(file_exists($templatedir."/".$template.".".$ext)) {
			$tplcache[$template] = implode("",file($templatedir."/".$template.".".$ext));
		} else {
			return "<p><center><b>Schwerer Fehler im System, konnte Template \""
			      .$tpldir."/".$template.".".$ext."\" nicht finden!</b></center></p>";
			exit;
		}
	}
	return str_replace("\"","\\\"",$tplcache[$template]);
}
/*
* return: den template source
* param: template string
* usage: eval("print dooutput(\"".gettemplate("template string")."\");");
* desc: Ersetzt in template einige Codewrter zur Formatierung und gibt dann template aus
*/
function dooutput($template) {
  
  	global $elem, $elemres, $db_host, $db_name, $db_user, $db_pass, $db_tab, $stylearr, $go, $bsx_conf;
  	
  	if(! isset($stylearr)) $stylearr = getstyle();
  	
  	$icon = "<a href=\"?nshow=advancednews&spalte=icon_title&s_val=".stripslashes($elem[icon_title])."\">"
	       ."<img src=\"".$bsx_conf[site_url]."gfx/icons/$elem[icon]\" border=\"0\" align=\"right\" valign=\"middle\""
	       ." hspace=\"10\" vspace=\"2\" alt=\"Zeige die letzten $bsx_conf[news_max] News\nzum Thema ".stripslashes($elem[icon_title])."!\"></a>";
	$author = "<a href=\"?nshow=advancednews&spalte=author&s_val=$elem[author]\""
		 ." title=\"Zeige die letzten $bsx_conf[news_max] News von $elem[author]!\">$elem[author]</a>";
	$Link = "<a target=\"_blank\" href=\"".stripslashes($elem[Link])."\" title=\"".stripslashes($elem[Linktext])."\">".stripslashes($elem[Linktext])."</a>";
	
	if($elem[anz] == "0") {
		$comments = "<a href=\"?$QUERY_STRING&show_id=$elem[id]&nshow=shownewscom\">Kommentar schreiben</a>";
	} else {
		$comments = "<a href=\"?$QUERY_STRING&show_id=$elem[id]&nshow=shownewscom\">$elem[anz] Kommentar";
		if($elem[anz] != "1") $comments .= "e</a>"; else $comments .= "</a>";
	}
	if((file_exists("".$bsx_conf[site_path]."gfx/icons/$elem[icon]")) && (strlen($elem[icon]) > 4)) {
		$elem[icon] = $icon;
	} else {
		unset($elem[icon]);
	}
	if(strlen($elem[email]) > 5) {
		$comauthor = "<a href=\"mailto:$elem[email]?subject=Re: ".stripslashes($elem[title])."\">$elem[author]</a>";
	} else {
		$comauthor = $elem[author];
	}
	if((! isset($Jahre)) || ($Jahre == "")) {
		for ($year = 2002; $year <= date("Y", time()); $year++) {
            		$Jahre .= "<option>$year</option>\n";
        	}
        }
	
	$elem[news] = str_replace("\'","'",$elem[news]);
    	$template = str_replace("{tdchange}", $elem[tdchange],$template);
    	$template = str_replace("{tdchangeclass}", $elem[tdchangeclass],$template);
   	$template = str_replace("{Jahre}","$Jahre",$template);
    	$template = str_replace("{titlebg}","$stylearr[titlebg]",$template);
    	$template = str_replace("{catbg}","$stylearr[catbg]",$template);
 	$template = str_replace("{taba}","$stylearr[taba]",$template);
 	$template = str_replace("{tabb}","$stylearr[tabb]",$template);
 	$template = str_replace("{tabc}","$stylearr[tabc]",$template);
 	$template = str_replace("{tabout}","$stylearr[tabout]",$template);
 	$template = str_replace("{fontface}","$stylearr[fontface]",$template);
 	$template = str_replace("{fontcolor}","$stylearr[fontcolor]",$template);
 	$template = str_replace("{fontsize}","$stylearr[fontsize]",$template);
 	$template = str_replace("{tfontcolor}","$stylearr[titelfontcolor]",$template);
 	$template = str_replace("{tfontsize}","$stylearr[titelfontsize]",$template);
 	$template = str_replace("{cfontcolor}","$stylearr[catfontcolor]",$template);
 	$template = str_replace("{cfontsize}","$stylearr[catfontsize]",$template);
 	$template = str_replace("{linkn}","$stylearr[link]",$template);
 	$template = str_replace("{linka}","$stylearr[linka]",$template);
 	$template = str_replace("{linkv}","$stylearr[linkv]",$template);
 	
 	$template = str_replace("{nav_link}","".stripslashes($elem[cattitel])."",$template);
 	$template = str_replace("{title}","".stripslashes($elem[title])."",$template);
 	$template = str_replace("{comment}","".stripslashes(smilie(ubb($elem[comment])))."",$template);
 	$template = str_replace("{news}","".stripslashes(smilie(ubb($elem[news])))."",$template);
 	$template = str_replace("{icon}","$elem[icon]",$template);
 	$template = str_replace("{Link}","$Link",$template);  
 	$template = str_replace("{author}","".stripslashes($author)."",$template);
 	$template = str_replace("{comauthor}","".stripslashes($comauthor)."",$template);
 	$template = str_replace("{Datum}","".date("d.m.Y", $elem[Datum])." um ".date("H:i", $elem[Datum])."",$template);
 	$template = str_replace("{comments}","$comments",$template);
 	$template = str_replace("{headlinetitel}", stripslashes($elem[title]),$template);
 	$template = str_replace("{headlinenews}", stripslashes(smilie(ubb($elem[news]))),$template);
 	$template = str_replace("{headlinedatum}", date("d.m.y", $elem[Datum]),$template);
 	$template = str_replace("{headlinelnk}", $elem[lnk],$template);
 	$template = str_replace("{searchresult}", $elem[searchres],$template);
 	
 	return stripslashes($template);
 	unset($template);
}
/*
* return: den formatierten string
* param: string
* usage: $string = ubb($string);
* desc: tauscht die bekannten ubb [*] Tags gegen echte html tags aus
*/
function ubb ($string) {

	$string = str_replace("\n","<br>",$string);
	$string = str_replace(chr(13)," ",$string);
	$string = str_replace(chr(10)," ",$string);
	$string = str_replace("\n","",$string);
	$string = eregi_replace("\\[U]([^\\[]*)\\[/U]","<u>\\1</u>",$string);
	$string = eregi_replace("\\[B]([^\\[]*)\\[/B]","<b>\\1</b>",$string);
	$string = eregi_replace("\\[I]([^\\[]*)\\[/I]","<i>\\1</i>",$string);
	$string = eregi_replace("\\[CENTER]([^\\[]*)\\[/CENTER]","<center>\\1</center>",$string);
	$string = eregi_replace("\\[URL=([^\\[]*)\\]([^\\[]*)\\[/URL\\]","<a href=\"\\1\" target=\"_blank\">\\2</a>",$string);
	$string = eregi_replace("\\[URL\\]([^\\[]*)\\[/URL\\]","<a href=\"\\1\" target=\"_blank\">\\1</a>",$string);
	$string = eregi_replace("\\[ICQ=([^\\[]*)\\]([^\\[]*)\\[/ICQ\\]","<a href=\"http://wwp.icq.com/scripts/Search.dll?to=\\1\">\\2</a>",$string);
	$string = eregi_replace("\\[ICQ\\]([^\\[]*)\\[/ICQ\\]","<a href=\"http://wwp.icq.com/scripts/Search.dll?to=\\1\">\\1</a>",$string);
	$string = eregi_replace("\\[COLOR=([^\\[]*)\\]([^\\[]*)\\[/COLOR\\]","<font color=\\1>\\2</font>",$string);
	$string = eregi_replace("\\[MAIL=([^\\[]*)\\]([^\\[]*)\\[/MAIL\\]","<a href=\"mailto:\\1\">\\2</a>",$string);
	$string = eregi_replace("\\[MAIL\\]([^\\[]*)\\[/MAIL\\]","<a href=\"mailto:\\1\">\\1</a>",$string);
	$string = eregi_replace("\\[IMG]([^\\[]*)\\[/IMG]","<img src=\"\\1\" border=0>",$string);
	$string = eregi_replace("\\[QUOTE]([^\\[]*)\\[/QUOTE]","\n<br><ul>Zitat:<br>\n<hr width=\"90%\" size=1><blockquote> \\1 </blockquote><br>\n<hr width=\"90%\" size=\"1\"></ul>",$string);

	return $string;
}
/*
* return: den formatierten string
* param: string
* usage: $string = smilie($string);
* desc: tauscht die bekannten smilie Krzel gegen echte html tags aus
*/
function smilie ($string) {
	
	global $bsx_conf;

	$string = str_replace("8o","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/bigeek.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"geschockt\">&nbsp;",$string);
	$string = str_replace(":D","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/biggrin.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Big smile\">&nbsp;",$string);
	$string = str_replace(":P","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/bigrazz.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Zunge raus\">&nbsp;",$string);
	$string = str_replace("8)","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/cool.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Cool\">&nbsp;",$string);
	$string = str_replace(":[","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/cry.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"traurig\">&nbsp;",$string);
	$string = str_replace(":]","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/laugh.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Lol\">&nbsp;",$string);
	$string = str_replace("X(","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/mad.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"bse\">&nbsp;",$string);
	$string = str_replace(":N","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/no.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"N\">&nbsp;",$string);  
	$string = str_replace(":|","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/none.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Nix\">&nbsp;",$string);
	$string = str_replace(":rolleyes:","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/rolleyes.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Augen Rollen\">&nbsp;",$string);
	$string = str_replace(":(","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/sad.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"unglcklich\">&nbsp;",$string);           
	$string = str_replace(":)","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/smile.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Smile\">&nbsp;",$string);              
	$string = str_replace(";D","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/smilewinkgrin.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Happy grins\">&nbsp;",$string); 
	$string = str_replace(";)","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/wink.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Augen zwinkern\">&nbsp;",$string);     
	$string = str_replace(":Y","&nbsp;<img src=\"$bsx_conf[site_url]gfx/smilies/yes.gif\" border=\"0\" width=\"15\" height=\"15\" alt=\"Jo\">&nbsp;",$string);
	
	return $string;
}
/*
* return: array style_cache
* param: /
* usage: $style_cache = getstyle();
* desc: holt sich den style aus der db und legt es als array $style_cache an
*/
function getstyle () {
  	
  	global $style_cache, $db_host, $db_name, $db_user, $db_pass, $db_tab;
  	
	if(! isset($style_cache)) {
	 	$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
	 	$style_cache = $dbcon->db_fetch("SELECT * FROM $db_tab[style] WHERE standard = 'Jo'");
	 	$close = $dbcon->close();
	 	//if($style_cache)  session_register($style_cache);
	}
	return $style_cache;
}
/*
* return: den css header -> string 
* param: /
* usage: print showcss();
* desc: wenn noch nicht vorhanden holt sich css style aus db und gibt als string zurck
*/
function showcss () {
	
	global $style_cache, $bsx_conf;
	
	if(! isset($bsx_conf)) $bsx_conf = get_config();
	if(! isset($style_cache)) $style_cache = getstyle();
	return stripslashes(str_replace("{script_url}", $bsx_conf[site_url],$style_cache[style]));
}
/*
* return: Das Array mit from & to 
* param: $month & $year
* usage: $array = kalendar($month, $year);
* desc: gibt den 1. und den letzten Datums wert im Monat als unix Timestamp an (fr Datenbank suche nach timewerten)
*/
function kalendar ($month, $year) {

	switch ($month) {
		case "January": $lastday = 31;
		break;
		case "February": if ($year % 4 == 0) { $lastday = 29; } else { $lastday = 28; }
		break;
		case "March": $lastday = 31;
		break;
		case "April": $lastday = 30;
		break;
		case "May": $lastday = 31;
		break;
		case "June": $lastday = 30;
		break;
		case "July": $lastday = 31;
		break;
		case "August": $lastday = 31;
		break;
		case "September": $lastday = 30;
		break;
		case "October": $lastday = 31;
		break;
		case "November": $lastday = 30;
		break;
		case "December": $lastday = 31;
		break;
		default: $lastday = 30;
	}
	$dat[from] = strtotime("1 $month $year 00:00:00");     
	$dat[to] = strtotime("$lastday $month $year 23:59:59");
	return $dat;
}
/*
* return: 
* param: 
* usage: 
* desc: holt sich die allgemeinen Einstellungen und speichert in acp/cache/conf.inc.php 
*/
function get_config () {
	
  	global $bsx_conf, $db_host, $db_name, $db_user, $db_pass, $db_tab;
	
	$dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
	$query = $dbcon->db_fetch("SELECT * FROM ".$db_tab[config]);
	$close = $dbcon->close();
	if(! $query) {
		return "<p><center>Datenbank Probleme??</center></p>\n";
		exit;
	}
	$bsx_conf = $query;
	return $bsx_conf;
	unset($query);
}
/*
* return: string (links)
* param: Position, maximal angezeigte pro seite, menge der insgesamten datenstze
* usage: print site_view($go, $max_view, $result_anz);
* desc: zeigt datenstze seite weise an 
*/
function site_view ($go, $max_view, $result_anz) {
	
	global $QUERY_STRING;
	
	$QUERY_STRING = ereg_replace("&go=([0-9])", "", $QUERY_STRING);
	$seiten = ceil($result_anz / $max_view);
	
	if($seiten > 1) {
		if($go > 0) {
			$link = "[ <a href=\"?$QUERY_STRING&go=0\">erste Seite</a> ]";
			$back = $go - $max_view;
			if($back < 0) $back = 0;
			if($go >= $max_view) $link .= "&nbsp;[ <a href=\"?$QUERY_STRING&go=$back\">eine Seite zurck</a> ]";
		}
		for($n = 1; $n <= $seiten; $n++) {
  			$fwd = ($n - 1) * $max_view;
  			if($go == $fwd) $link .= "&nbsp;$n"; else $link .= "&nbsp;<a href=\"?$QUERY_STRING&go=$fwd\">$n</a>";
		}
		if($go < $result_anz - $max_view) {
			$fwd = $go + $max_view;
			$link .= "&nbsp;[ <a href=\"?$QUERY_STRING&go=$fwd\">eine Seite weiter</a> ]";
			$fwd = $result_anz - $max_view;
			$link .= "&nbsp;[ <a href=\"?$QUERY_STRING&go=$fwd\">letzte Seite</a> ]";
		}
	}
	return $link;	
}
?>