<?php

/*
* BSX-SQL v 01.00.00 by BetaSux (C) 2003
* required PHP version: at least 4.0
* contact: betasux@gmx.net
* last modified: 02.11.2003
* short usage description over each function...
*/

class db_bsx {

	var $host;
	var $db;
	var $user;
	var $pass;
	var $query;
	var $result;
	var $result_multi;
	var $anz;
	var $n;
	var $show_error = 1; 					// Error Messages 1 = anzeigen, 0 = nicht anzeigen
	var $application = "Bsx-News";			// Name der Application fr die BSX-SQL einegesetzt wird
/*
* return: ok=true scheisse Fehlermeldung
* param: $db_host, $db_name, $db_user und $db_pass
* usage: $dbcon = new db_bsx($db_host, $db_name, $db_user, $db_pass);
* desc: stellt verbindung zur db her ...
*/
	function db_bsx($db_host, $db_name, $db_user, $db_pass) {

    	$this->host = $db_host;
    	$this->db   = $db_name;
    	$this->user = $db_user;
    	$this->pass = $db_pass;
    	
    	$this->con_id = mysql_connect($this->host, $this->user, $this->pass);
    	if(! $this->con_id) {
			$this->print_error("Connect-ID falsch! Konnte keine Verbindung aufbauen!");
        } else {
        	if(mysql_select_db($this->db, $this->con_id)) {
        		return true;
        	} else {
        		$this->print_error("kann Datenbank ".$this->database." nicht finden!");
        	}
        }
	}
/*
* return: string
* param: /
* usage: 
* desc: holt Fehler Beschreibung
*/
	function get_errordesc() {
		
    	$this->error = mysql_error();
    	return $this->error;
  	}
/*
* return: string
* param: /
* usage: 
* desc: holt Fehler Nummer
*/
  	function get_errornr() {
  		
    	$this->errornr = mysql_errno();
    	return $this->errornr;
  	}
/*
* return: ok=true scheisse=false
* param: $anweis
* usage: $query = $dbcon->db_ins("UPDATE table SET field = 'something'");
* usage: $query = $dbcon->db_ins("INSERT INTO table (field, field) VALUES ('something', 'something')");
* usage: $query = $dbcon->db_ins("DELETE FROM table WHERE field = 'something'");
* desc: fgt eintrge in die db ein, bzw. ndert vorhandene Eintrge oder lscht eintrge
*/
	function db_ins($anweis) {

		$this->query = mysql_query($anweis);
		if($this->query) return true; else $this->print_error("Fehlerhafte SQL Anweisung: ".$anweis);
	}
/*
* return: bool or string
* param: $anweis
* usage: $result = $dbcon->db_fetch("SELECT * FROM table WHERE field != 'something'");
* desc: holt ein ergebnis aus db ... oder gibt Fehlermeldung zurck
*/
	function db_fetch($anweis) {

		$this->query = mysql_query($anweis);
		$this->result = mysql_fetch_array($this->query);
		if(! $this->result) $this->print_error("Fehlerhafte SQL Anweisung: ".$anweis);
		return $this->result;
	}
/*
* return: $result_multi
* param: $anweis
* usage: $result = $dbcon->db_fetch_multi("SELECT * FROM table WHERE field LIKE '%omethin%'");
*            foreach ($result as $result_detail) {
*                print "<tr>\n";
*                foreach ($result_detail as $key=>$elem) {
*                    print "<td>$elem[value]</td>\n";
*                }
*                print "</tr>\n";
*            }
* desc: ausgabe und auch suchfunktion in der db ...
*/
	function db_fetch_multi($anweis) {

		$this->query = mysql_query($anweis);
		if(! $this->query) $this->print_error("Fehlerhafte SQL Anweisung: ".$anweis);
		$this->n = 0;
		while($this->result = mysql_fetch_array($this->query)) {
			$this->result_multi[$this->n] = array($this->result);
			$this->n++;
		}
		return $this->result_multi;
	}
/*
* return: $anz
* param: $anweis
* usage: $rows = $dbcon->db_rows("SELECT * FROM table WHERE field = 'something'");
* desc: Zhler ...
*/
	function db_rows($anweis) {

		$this->query = mysql_query($anweis);
		if(! $this->query) $this->print_error("Fehlerhafte SQL Anweisung: ".$anweis);
		$this->anz = mysql_num_rows($this->query);
		return $this->anz;
	}
/*
* return: ok=true scheisse=false
* param:
* usage: $close = $dbcon->close();
* desc: scliesst db ...
*/
	function close() {

		if(mysql_close()) {
			return true;
		} else {
			return false;
		}
	}
/*
* return: Error Message
* param: Error String
* usage: $this->print_error("CON-ID == false, Connecting failed!");
* desc: Gibt die message mit dem Datenbank Fehler zurck
*/
  	function print_error($msg) {
    		$this->errordesc = mysql_error();
    		$this->errornr = mysql_errno();
    		
    		$message="Datenbank Fehler in $this->application: $msg<br>\n"
    			."<b>Mysql-Error:</b> $this->errordesc<br>\n"
    			."<b>Mysql-Error-Nummer:</b> $this->errornr<br>\n"
    			."<b>Datum:</b> ".date("d.m.Y um H:i")."<br>\n"
    			."<b>Script:</b> ".getenv("REQUEST_URI")."<br>\n"
    			."<b>Referer:</b> ".getenv("HTTP_REFERER")."\n<br><br>";

    		if($this->show_error) {
    			print "<p>$message</p>";
    		} else {
    			print "\n<!--\n<p>$message</p>\n-->\n";
    		}
      		die("");
    }

} // db_bsx

?>